# Class SybasePkGenerator

java.lang.Object
org.apache.cayenne.dba.JdbcPkGenerator
org.apache.cayenne.dba.sybase.SybasePkGenerator

All Implemented Interfaces:
  `PkGenerator`

public class SybasePkGenerator extends JdbcPkGenerator
Primary key generator implementation for Sybase. Uses a lookup table named "AUTO_PK_SUPPORT" and a stored procedure "auto_pk_for_table" to search and increment primary keys for tables.

- ## Field Summary

  ### Fields inherited from class JdbcPkGenerator

  `adapter, DEFAULT_PK_CACHE_SIZE, pkCache, pkCacheSize, pkStartValue`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SybasePkGenerator(JdbcAdapter adapter)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `createAutoPk(DataNode node, List<DbEntity> dbEntities)`
  Generates database objects to provide automatic primary key support.
  `List<String>`
  `createAutoPkStatements(List<DbEntity> dbEntities)`
  Returns a list of SQL strings needed to generates database objects to provide automatic primary support for the list of entities.
  `void`
  `dropAutoPk(DataNode node, List<DbEntity> dbEntities)`
  Drops database objects related to automatic primary key support.
  `List<String>`
  `dropAutoPkStatements(List<DbEntity> dbEntities)`
  Returns SQL string needed to drop database objects associated with automatic primary key generation.
  `protected long`
  `longPkFromDatabase(DataNode node, DbEntity entity)`
  Performs primary key generation ignoring cache.
  `protected String`
  `pkTableCreateString()`

  ### Methods inherited from class JdbcPkGenerator

  `autoPkTableExists, dropAutoPkString, generatePk, getAdapter, getPkCacheSize, pkCreateString, pkDeleteString, pkSelectString, pkUpdateString, reset, runUpdate, setPkCacheSize`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface PkGenerator

  `generatePk`

- ## Constructor Details

  - ### SybasePkGenerator

    public SybasePkGenerator(JdbcAdapter adapter)

- ## Method Details

  - ### pkTableCreateString

    protected String pkTableCreateString()
    Overrides:
      `pkTableCreateString` in class `JdbcPkGenerator`

  - ### createAutoPk

    public void createAutoPk(DataNode node, List<DbEntity> dbEntities)
    Generates database objects to provide automatic primary key support. Method will execute the following SQL statements:

    1. Executed only if a corresponding table does not exist in the database.

           CREATE TABLE AUTO_PK_SUPPORT (
              TABLE_NAME VARCHAR(32) NOT NULL,
              NEXT_ID DECIMAL(19,0) NOT NULL
           )

    2. Executed under any circumstances.

        if exists (SELECT * FROM sysobjects WHERE name = 'auto_pk_for_table')
        BEGIN
           DROP PROCEDURE auto_pk_for_table
        END

    3. Executed under any circumstances.

    CREATE PROCEDURE auto_pk_for_table

        @tname VARCHAR(32),
        @pkbatchsize INT AS BEGIN BEGIN TRANSACTION UPDATE AUTO_PK_SUPPORT set NEXT_ID =
                     NEXT_ID +
        @pkbatchsize WHERE TABLE_NAME =
        @tname SELECT NEXT_ID from AUTO_PK_SUPPORT where NEXT_ID =
        @tname COMMIT END

    Specified by:
      `createAutoPk` in interface `PkGenerator`
    Overrides:
      `createAutoPk` in class `JdbcPkGenerator`
    Parameters:
      `node` - node that provides access to a DataSource.
      `dbEntities` - a list of entities that require primary key auto-generation support

  - ### createAutoPkStatements

    public List<String> createAutoPkStatements(List<DbEntity> dbEntities)
    Description copied from interface: `PkGenerator`
    Returns a list of SQL strings needed to generates database objects to provide automatic primary support for the list of entities. No actual database operations are performed.
    Specified by:
      `createAutoPkStatements` in interface `PkGenerator`
    Overrides:
      `createAutoPkStatements` in class `JdbcPkGenerator`

  - ### dropAutoPk

    public void dropAutoPk(DataNode node, List<DbEntity> dbEntities)
    Drops database objects related to automatic primary key support. Method will execute the following SQL statements:

        if exists (SELECT * FROM sysobjects WHERE name = 'AUTO_PK_SUPPORT')
        BEGIN
           DROP TABLE AUTO_PK_SUPPORT
        END

        if exists (SELECT * FROM sysobjects WHERE name = 'auto_pk_for_table')
        BEGIN
           DROP PROCEDURE auto_pk_for_table
        END

    Specified by:
      `dropAutoPk` in interface `PkGenerator`
    Overrides:
      `dropAutoPk` in class `JdbcPkGenerator`
    Parameters:
      `node` - node that provides access to a DataSource.
      `dbEntities` - a list of entities whose primary key auto-generation support should be dropped.

  - ### dropAutoPkStatements

    public List<String> dropAutoPkStatements(List<DbEntity> dbEntities)
    Description copied from interface: `PkGenerator`
    Returns SQL string needed to drop database objects associated with automatic primary key generation. No actual database operations are performed.
    Specified by:
      `dropAutoPkStatements` in interface `PkGenerator`
    Overrides:
      `dropAutoPkStatements` in class `JdbcPkGenerator`

  - ### longPkFromDatabase

    protected long longPkFromDatabase(DataNode node, DbEntity entity)
    Description copied from class: `JdbcPkGenerator`
    Performs primary key generation ignoring cache. Generates a range of primary keys as specified by "pkCacheSize" bean property.

    This method is called internally from "generatePkForDbEntity" and then generated range of key values is saved in cache for performance. Subclasses that implement different primary key generation solutions should override this method, not "generatePkForDbEntity".

    Overrides:
      `longPkFromDatabase` in class `JdbcPkGenerator`
    Since:
      3.0